diff --git a/web/pgadmin/tools/search_objects/static/js/search_objects_dialog_wrapper.js b/web/pgadmin/tools/search_objects/static/js/search_objects_dialog_wrapper.js
new file mode 100644
index 000000000..926c5cf43
--- /dev/null
+++ b/web/pgadmin/tools/search_objects/static/js/search_objects_dialog_wrapper.js
@@ -0,0 +1,614 @@
+import {getTreeNodeHierarchyFromElement} from 'sources/tree/pgadmin_tree_node';
+import axios from 'axios/index';
+import gettext from 'sources/gettext';
+import url_for from 'sources/url_for';
+import 'select2';
+import {DialogWrapper} from 'sources/alertify/dialog_wrapper';
+import Slick from 'sources/../bundle/slickgrid';
+import pgAdmin from 'sources/pgadmin';
+
+
+export default class SearchObjectsDialogWrapper extends DialogWrapper {
+  constructor(dialogContainerSelector, dialogTitle, typeOfDialog,
+    jquery, pgBrowser, alertify, dialogModel, backform) {
+    super(dialogContainerSelector, dialogTitle, jquery,
+      pgBrowser, alertify, dialogModel, backform);
+
+    this.grid = null;
+    this.gridContainer = null;
+  }
+
+  showMessage(text, is_error, call_after_show=()=>{}) {
+    if(text == '' || text == null) {
+      this.statusBar.classList.add('d-none');
+    } else {
+      if(is_error) {
+        this.statusBar.innerHTML = `
+          <div class="error-in-footer">
+            <div class="d-flex px-2 py-1">
+              <div class="pr-2">
+                <i class="fa fa-exclamation-triangle text-danger" aria-hidden="true" role="img"></i>
+              </div>
+              <div role="alert" class="alert-text">${text}</div>
+              <div class="ml-auto close-error-bar">
+                <a class="close-error fa fa-times text-danger"></a>
+              </div>
+            </div>
+          </div>
+        `;
+
+        this.statusBar.querySelector('.close-error').addEventListener('click', ()=>{
+          this.showMessage(null);
+        });
+      } else {
+        this.statusBar.innerHTML = `
+          <div class="info-in-footer">
+            <div class="d-flex px-2 py-1">
+              <div class="pr-2">
+                <i class="fa fa-info-circle text-primary" aria-hidden="true"></i>
+              </div>
+              <div class="alert-text" role="alert">${text}</div>
+            </div>
+          </div>
+        `;
+      }
+      this.statusBar.classList.remove('d-none');
+      call_after_show(this.statusBar);
+    }
+  }
+
+  createDialogDOM(dialogContainer) {
+    dialogContainer.innerHTML = `
+      <div class="d-flex flex-column w-100 h-100">
+        <div class="p-2">
+          <div class="row">
+            <div class="col-8 d-flex">
+              <div class="input-group pgadmin-controls">
+                  <div class="input-group-prepend">
+                      <span class="input-group-text fa fa-search" id="labelSearch" aria-label="` + gettext('Search') + `"></span>
+                  </div>
+                  <input type="search" class="form-control" id="txtGridSearch" placeholder="` + gettext('Type at least 3 characters') + `"
+                    tabindex="0" aria-describedby="labelSearch" aria-labelledby="labelSearch" autocomplete="off">
+              </div>
+              <div class="ml-2">
+                <button class="btn btn-primary btn-search" disabled>${ gettext('Search') }</button>
+              </div>
+            </div>
+            <div class="col-4">
+              <select class="node-types"></select>
+            </div>
+          </div>
+        </div>
+        <div class="search-result-container flex-grow-1">
+          <div class="pg-sp-container d-none">
+            <div class="pg-sp-content">
+              <div class="row"><div class="col-12 pg-sp-icon"></div></div>
+              <div class="row"><div class="col-12 pg-sp-text"></div></div>
+            </div>
+          </div>
+          <div class="search-result"></div>
+        </div>
+        <div class=\'pg-prop-status-bar pg-el-xs-12\'>
+        </div>
+      </div>
+    `;
+
+    return dialogContainer;
+  }
+
+  updateDimOfSearchResult() {
+    let dim = this.searchResultContainer.getBoundingClientRect();
+    this.searchResult.style.height = dim.height + 'px';
+    this.searchResult.style.width = dim.width + 'px';
+  }
+
+  setLoading(text) {
+    if(text != null) {
+      this.loader.classList.remove('d-none');
+      this.loader.querySelector('.pg-sp-text').innerHTML = text;
+    } else {
+      this.loader.classList.add('d-none');
+    }
+  }
+
+  searchBtnEnabled(enabled) {
+    if(typeof(enabled) != 'undefined') {
+      this.searchBtn.disabled = !enabled;
+    } else {
+      return !this.searchBtn.disabled;
+    }
+  }
+
+  searchBoxVal(val) {
+    if(typeof(val) != 'undefined') {
+      this.searchBox.value = val;
+    } else {
+      return this.searchBox.value.trim();
+    }
+  }
+
+  typesVal(val) {
+    if(typeof(val) != 'undefined') {
+      this.typesSelect.value = val;
+    } else {
+      return this.typesSelect.value;
+    }
+  }
+
+  setTypes(data, enabled=true) {
+    this.jquery(this.typesSelect).empty().select2({
+      data: data,
+    });
+
+    this.typesSelect.disabled = !enabled;
+  }
+
+  showOtherInfo(rowno) {
+    let data = this.grid.getData();
+    let rowData = data[rowno];
+    rowData.name += ` (${rowData.other_info})`;
+    rowData.other_info = null;
+    data[rowno] = rowData;
+    this.setGridData(data);
+  }
+
+  setGridData(data) {
+    data.getItemMetadata = (row)=>{
+      if(data[row] && !data[row].show_node){
+        return {
+          cssClasses: 'object-muted',
+        };
+      }
+      return null;
+    };
+    this.grid.setData(data);
+    this.grid.resizeCanvas();
+  }
+
+  prepareGrid() {
+    this.grid = new Slick.Grid(
+      this.searchResult,
+      [],
+      [
+        { id: 'name', name: 'Object name', field: 'name', sortable: true,
+          formatter: (row, cell, value, columnDef, dataContext) => {
+            let ret_el = `<i class='wcTabIcon ${dataContext.icon}'></i>${value}`;
+
+            if(dataContext.other_info != null && dataContext.other_info != '') {
+              ret_el += '&nbsp;<span class="object-other-info">(...)</span>';
+            }
+
+            return ret_el;
+          },
+          width: 50,
+        },
+        { id: 'type', name: 'Type', field: 'type_label', sortable: true, width: 35 },
+        { id: 'path', name: 'Path', field: 'path', sortable: false },
+      ],
+      {
+        enableCellNavigation: true,
+        enableColumnReorder: false,
+        multiColumnSort: true,
+        explicitInitialization: true,
+      }
+    );
+
+    this.grid.registerPlugin(new Slick.AutoColumnSize());
+
+    this.grid.setSelectionModel(new Slick.RowSelectionModel({selectActiveRow: true}));
+
+    this.grid.onKeyDown.subscribe((event) => {
+      let activeRow = this.grid.getActiveCell();
+      if(activeRow && !event.ctrlKey && !event.altKey && !event.metaKey && event.keyCode == 9) {
+        event.preventDefault();
+        event.stopImmediatePropagation();
+
+        if(event.shiftKey) {
+          this.prevToGrid.focus();
+        } else {
+          this.nextToGrid.focus();
+        }
+      }
+    });
+
+    this.grid.onClick.subscribe((event, args) => {
+      if(event.target.classList.contains('object-other-info')) {
+        this.showOtherInfo(args.row);
+      }
+    });
+
+    this.grid.onDblClick.subscribe((event, args) => {
+      let rowData = this.grid.getDataItem(args.row);
+      let treeMenu = this.pgBrowser.treeMenu;
+
+      if(!rowData.show_node) {
+        this.showMessage(
+          gettext('%s objects are disabled in the browser.', rowData.type) + ' ' +
+          gettext('You can enable them in the') + ' <a class="pref-dialog-link">' + gettext('preferences dialog') + '</a>',
+          true,
+          (statusBar)=>{
+            statusBar.querySelector('.pref-dialog-link').addEventListener('click', ()=>{
+              if(pgAdmin.Preferences) {
+                pgAdmin.Preferences.show();
+              }
+            });
+          }
+        );
+        return false;
+      }
+      this.showMessage(gettext('Locating...'));
+      treeMenu.findNodeWithToggle(rowData.id_path)
+        .then((treeItem)=>{
+          treeMenu.selectNode(treeItem.domNode, true);
+          this.showMessage(null);
+        })
+        .catch((args)=>{
+          this.showMessage(gettext('Unable to locate this object in the browser.'), true);
+          console.warn(args);
+        });
+    });
+
+    this.grid.onSort.subscribe((event, args) => {
+      let cols = args.sortCols;
+      let data = this.grid.getData();
+
+      data.sort(function (dataRow1, dataRow2) {
+        for (var i = 0, l = cols.length; i < l; i++) {
+          var field = cols[i].sortCol.field;
+          var sign = cols[i].sortAsc ? 1 : -1;
+          var value1 = dataRow1[field], value2 = dataRow2[field];
+          var result = (value1 == value2 ? 0 : (value1 > value2 ? 1 : -1)) * sign;
+          if (result != 0) {
+            return result;
+          }
+        }
+        return false;
+      });
+      this.setGridData(data);
+    });
+  }
+
+  onDialogResize() {
+    this.updateDimOfSearchResult();
+
+    if(this.grid) {
+      this.grid.resizeCanvas();
+      this.grid.autosizeColumns();
+    }
+  }
+
+  onDialogShow() {
+    this.focusOnDialog(this);
+
+    setTimeout(()=>{
+      if(!this.grid) {
+        this.prepareGrid();
+      }
+      this.updateDimOfSearchResult();
+      this.grid.init();
+      this.setGridData([]);
+      this.onDialogResize();
+    }, 500);
+  }
+
+  getBaseUrl(endpoint) {
+    return url_for('search_objects.'+endpoint, {
+      sid: this.treeInfo.server._id,
+      did: this.treeInfo.database._id,
+    });
+  }
+
+  getCollNode(node_type) {
+    if('coll-'+node_type in this.pgBrowser.Nodes) {
+      return this.pgBrowser.Nodes['coll-'+node_type];
+    } else if(node_type in this.pgBrowser.Nodes &&
+              typeof(this.pgBrowser.Nodes[node_type].collection_type) === 'string') {
+      return this.pgBrowser.Nodes[this.pgBrowser.Nodes[node_type].collection_type];
+    }
+
+    return null;
+  }
+
+  getSelectedNode() {
+    const tree = this.pgBrowser.treeMenu;
+    const selectedNode = tree.selected();
+    if (selectedNode) {
+      return tree.findNodeByDomElement(selectedNode);
+    } else {
+      return undefined;
+    }
+  }
+
+  finaliseData(datum) {
+    datum.icon = 'icon-' + datum.type;
+    /* finalise path */
+    [datum.path, datum.id_path] = this.translateSearchObjectsPath(datum.path, datum.catalog_level);
+    return datum;
+  }
+
+  /* This function will translate the path given by search objects API into two parts
+   * 1. The display path on the UI
+   * 2. The tree search path to locate the object on the tree.
+   *
+   * Sample path returned by search objects API
+   * :schema.11:/pg_catalog/:table.2604:/pg_attrdef
+   *
+   * Sample path required by tree locator
+   * Normal object  - server_group/1.server/3.coll-database/3.database/13258.coll-schema/13258.schema/2200.coll-table/2200.table/41773
+   * pg_catalog schema - server_group/1.server/3.coll-database/3.database/13258.coll-catalog/13258.catalog/11.coll-table/11.table/2600
+   * Information Schema, dbo, sys    - server_group/1.server/3.coll-database/3.database/13258.coll-catalog/13258.catalog/12967.coll-catalog_object/12967.catalog_object/13204
+   *
+   * Column catalog_level has values as
+   * N - Not a catalog schema
+   * D - Catalog schema with DB support - pg_catalog
+   * O - Catalog schema with object support only - info schema, dbo, sys
+   */
+  translateSearchObjectsPath(path, catalog_level) {
+    if (path === null) {
+      return path;
+    }
+
+    catalog_level = catalog_level || 'N';
+
+    /* path required by tree locator */
+    /* the path received from the backend is after the DB node, initial path setup */
+    let id_path = [
+      this.treeInfo.server_group.id,
+      this.treeInfo.server.id,
+      this.getCollNode('database').type + '/' + this.treeInfo.server._id,
+      this.treeInfo.database.id,
+    ];
+
+    let prev_node_id = this.treeInfo.database._id;
+
+    /* add the slash to match regex, remove it from display path later */
+    path = '/' + path;
+    /* the below regex will match all /:server_group.1:/ */
+    let new_path = path.replace(/\/:[a-zA-Z_]+\.[0-9]+:\//g, (token)=>{
+      let orig_token = token;
+      /* remove the slash and colon */
+      token = token.slice(2, -2);
+      let [node_type, node_oid, others] = token.split('.');
+      if(typeof(others) !== 'undefined') {
+        return token;
+      }
+
+      /* schema type is "catalog" for catalog schemas */
+      node_type = (['D', 'O'].indexOf(catalog_level) != -1 && node_type == 'schema') ? 'catalog' : node_type;
+
+      /* catalog like info schema will only have views and tables AKA catalog_object except for pg_catalog */
+      node_type = (catalog_level === 'O' && ['view', 'table'].indexOf(node_type) != -1) ? 'catalog_object' : node_type;
+
+      /* If collection node present then add it */
+      let coll_node = this.getCollNode(node_type);
+      if(coll_node) {
+        /* Add coll node to the path */
+        if(prev_node_id != null) id_path.push(`${coll_node.type}/${prev_node_id}`);
+
+        /* Add the node to the path */
+        id_path.push(`${node_type}/${node_oid}`);
+
+        /* This will be needed for coll node */
+        prev_node_id = node_oid;
+
+        /* This will be displayed in the grid */
+        return  `/${coll_node.label}/`;
+      } else if(node_type in this.pgBrowser.Nodes) {
+        /* Add the node to the path */
+        id_path.push(`${node_type}/${node_oid}`);
+
+        /* This will be need for coll node id path */
+        prev_node_id = node_oid;
+
+        /* Remove the token and replace with slash. This will be displayed in the grid */
+        return '/';
+      }
+      prev_node_id = null;
+      return orig_token;
+    });
+
+    /* Remove the slash we had added */
+    new_path = new_path.substring(1);
+    return [new_path, id_path];
+  }
+
+  prepareDialog() {
+    this.showMessage(null);
+    if(this.grid) {
+      this.grid.destroy();
+      this.grid = null;
+    }
+
+    /* Load types */
+    this.setTypes([{
+      id: -1,
+      text: gettext('Loading...'),
+      value: null,
+    }], false);
+
+    axios.get(
+      this.getBaseUrl('types')
+    ).then((res)=>{
+      let types = [{
+        id: 'all',
+        text: 'All types',
+      }];
+
+      for (const key of Object.keys(res.data.data).sort()) {
+        types.push({
+          id: key,
+          text: res.data.data[key],
+        });
+      }
+      this.setTypes(types);
+    }).catch(()=>{
+      this.setTypes([{
+        id: -1,
+        text: gettext('Failed'),
+        value: null,
+      }], false);
+    });
+  }
+
+  main(title) {
+    this.set('title', title);
+  }
+
+  setup() {
+    return {
+      buttons: [{
+        text: '',
+        key: 112,
+        className: 'btn btn-secondary pull-left fa fa-question pg-alertify-icon-button',
+        attrs: {
+          name: 'dialog_help',
+          type: 'button',
+          label: gettext('Help'),
+          'aria-label': gettext('Help'),
+          url: url_for('help.static', {
+            'filename': 'search_objects.html',
+          }),
+        },
+      }, {
+        text: gettext('Close'),
+        key: 27,
+        className: 'btn btn-secondary fa fa-lg fa-times pg-alertify-button',
+        'data-btn-name': 'cancel',
+      }],
+      // Set options for dialog
+      options: {
+        title: this.dialogTitle,
+        //disable both padding and overflow control.
+        padding: !1,
+        overflow: !1,
+        model: 0,
+        resizable: true,
+        maximizable: true,
+        pinnable: false,
+        closableByDimmer: false,
+        modal: false,
+      },
+    };
+  }
+
+  build() {
+    let tmpEle = document.createElement('div');
+    tmpEle.innerHTML = this.dialogContainerSelector;
+    let dialogContainer = tmpEle.firstChild;
+
+    // Append the container
+    this.elements.content.innerHTML = '';
+    this.elements.content.appendChild(dialogContainer);
+
+    this.createDialogDOM(dialogContainer);
+    this.alertify.pgDialogBuild.apply(this);
+
+    this.loader = dialogContainer.getElementsByClassName('pg-sp-container')[0];
+
+    this.searchBox = dialogContainer.querySelector('#txtGridSearch');
+    this.searchBtn = dialogContainer.querySelector('.btn-search');
+    this.typesSelect = dialogContainer.querySelector('.node-types');
+    this.searchResultContainer = dialogContainer.querySelector('.search-result-container');
+    this.searchResult = dialogContainer.querySelector('.search-result');
+    this.statusBar = dialogContainer.querySelector('.pg-prop-status-bar');
+
+    /* These two values are required to come out of grid when tab is
+     * pressed in the grid. Slickgrid does not allow any way to come out
+     */
+    this.nextToGrid = this.elements.footer.querySelector('.ajs-button');
+    this.prevToGrid = this.typesSelect;
+
+    /* init select2 */
+    this.setTypes([{
+      id: -1,
+      text: gettext('Loading...'),
+      value: null,
+    }], false);
+
+    /* on search box change */
+    this.searchBox.addEventListener('input', ()=>{
+      if(this.searchBoxVal().length >= 3) {
+        this.searchBtnEnabled(true);
+      } else {
+        this.searchBtnEnabled(false);
+      }
+    });
+
+    /* on enter key press */
+    this.searchBox.addEventListener('keypress', (e)=>{
+      if(e.keyCode == 13) {
+        e.stopPropagation();
+        if(this.searchBtnEnabled()) {
+          this.searchBtn.dispatchEvent(new Event('click'));
+        }
+      }
+    });
+
+    /* on search button click */
+    this.searchBtn.addEventListener('click', ()=>{
+      this.searchBtnEnabled(false);
+      this.setGridData([]);
+      this.showMessage(null);
+
+      this.setLoading(gettext('Searching....'));
+      axios.get(this.getBaseUrl('search'), {
+        params: {
+          text: this.searchBoxVal(),
+          type: this.typesVal(),
+        },
+      }).then((res)=>{
+        let grid_data = res.data.data.map((row)=>{
+          return this.finaliseData(row);
+        });
+
+        this.setGridData(grid_data);
+      }).catch((error)=>{
+        let errmsg = '';
+
+        if (error.response) {
+          errmsg = error.response.statusText;
+        } else if (error.request) {
+          errmsg = gettext('No response received');
+        } else {
+          errmsg = error.message;
+        }
+        this.showMessage(gettext('An unexpected occurred: %s', errmsg), true);
+        console.warn(error);
+      }).finally(()=>{
+        this.setLoading(null);
+        this.searchBtnEnabled(true);
+      });
+    });
+
+    this.set({
+      'onresized': this.onDialogResize.bind(this),
+      'onmaximized': this.onDialogResize.bind(this),
+      'onrestored': this.onDialogResize.bind(this),
+      'onshow': this.onDialogShow.bind(this),
+    });
+  }
+
+  prepare() {
+    let selectedTreeNode = this.getSelectedNode();
+    if (!this.getSelectedNodeData(selectedTreeNode)) {
+      return;
+    }
+
+    this.treeInfo = getTreeNodeHierarchyFromElement(this.pgBrowser, selectedTreeNode);
+    this.prepareDialog();
+    this.focusOnDialog(this);
+  }
+
+  callback(event) {
+    if (this.wasHelpButtonPressed(event)) {
+      event.cancel = true;
+      this.pgBrowser.showHelp(
+        event.button.element.name,
+        event.button.element.getAttribute('url'),
+        null,
+        null,
+      );
+      return;
+    }
+  }
+}
diff --git a/web/pgadmin/tools/search_objects/tests/test_api_search.py b/web/pgadmin/tools/search_objects/tests/test_api_search.py
new file mode 100644
index 000000000..3952006d2
--- /dev/null
+++ b/web/pgadmin/tools/search_objects/tests/test_api_search.py
@@ -0,0 +1,75 @@
+##########################################################################
+#
+# pgAdmin 4 - PostgreSQL Tools
+#
+# Copyright (C) 2013 - 2020, The pgAdmin Development Team
+# This software is released under the PostgreSQL Licence
+#
+##########################################################################
+
+from __future__ import print_function
+import sys
+import json
+
+from pgadmin.utils.route import BaseTestGenerator
+from regression import parent_node_dict
+from pgadmin.browser.server_groups.servers.databases.tests import utils as \
+    database_utils
+from regression.python_test_utils import test_utils as utils
+
+try:
+    from urllib import urlencode
+except Exception as e:
+    from urllib.parse import urlencode
+
+
+class SearchObjectsApiSearch(BaseTestGenerator):
+    """ This class will test search API of search objects. """
+    scenarios = [
+        ('Search with all types', dict(text='emp', type='all', singles=False)),
+        ('Search with None types', dict(text='emp', type=None, singles=False)),
+        ('Search for all single types',
+         dict(text='emp', type=None, singles=True)),
+    ]
+
+    def runFor(self, text=None, type=None):
+        url_params = dict(
+            text=text
+        )
+        if type is not None:
+            url_params['type'] = type
+
+        url_params = urlencode(url_params)
+        response = self.tester.get(self.base_url + '?' + url_params)
+
+        self.assertEquals(response.status_code, 200)
+
+    def runTest(self):
+        database_info = parent_node_dict["database"][-1]
+        server_id = database_info["server_id"]
+        db_id = database_info["db_id"]
+
+        db_con = database_utils.connect_database(self,
+                                                 utils.SERVER_GROUP,
+                                                 server_id,
+                                                 db_id)
+        if not db_con["info"] == "Database connected.":
+            raise Exception("Could not connect to database to add the schema.")
+
+        self.base_url = '/search_objects/search/' \
+                        + str(server_id) + '/' + str(db_id)
+
+        if not self.singles:
+            self.runFor(text=self.text, type=self.type)
+        else:
+            # test for all the node types individually
+            types_url = '/search_objects/types/' +\
+                        str(server_id) + '/' + str(db_id)
+            response = self.tester.get(types_url)
+            self.assertEquals(response.status_code, 200)
+            types_data = json.loads(response.data.decode('utf-8'))['data']
+
+            for a_type in types_data:
+                print('Running search for type {0}'.format(a_type),
+                      file=sys.stderr)
+                self.runFor(text=self.text, type=a_type)
diff --git a/web/pgadmin/tools/search_objects/tests/test_api_types.py b/web/pgadmin/tools/search_objects/tests/test_api_types.py
new file mode 100644
index 000000000..aed5571ad
--- /dev/null
+++ b/web/pgadmin/tools/search_objects/tests/test_api_types.py
@@ -0,0 +1,47 @@
+##########################################################################
+#
+# pgAdmin 4 - PostgreSQL Tools
+#
+# Copyright (C) 2013 - 2020, The pgAdmin Development Team
+# This software is released under the PostgreSQL Licence
+#
+##########################################################################
+
+import json
+from pgadmin.utils.route import BaseTestGenerator
+from regression import parent_node_dict
+from pgadmin.browser.server_groups.servers.databases.tests import utils as \
+    database_utils
+from regression.python_test_utils import test_utils as utils
+
+
+class SearchObjectsApiTypes(BaseTestGenerator):
+    """ This class will test types API of search objects. """
+    scenarios = [
+        # Fetching default URL for schema node.
+        ('Types API URL', dict(url='/search_objects/types'))
+    ]
+
+    def runTest(self):
+        database_info = parent_node_dict["database"][-1]
+        server_id = database_info["server_id"]
+
+        db_id = database_info["db_id"]
+        db_con = database_utils.connect_database(self,
+                                                 utils.SERVER_GROUP,
+                                                 server_id,
+                                                 db_id)
+        if not db_con["info"] == "Database connected.":
+            raise Exception("Could not connect to database to add the schema.")
+
+        url = self.url + '/' + str(server_id) + '/' + str(db_id)
+        response = self.tester.get(url)
+        self.assertEquals(response.status_code, 200)
+
+        # repsonse data should be dict
+        response_data = json.loads(response.data.decode('utf-8'))['data']
+        self.assertEquals(type(response_data), dict)
+
+        # response data key values should not be None
+        for key, value in response_data.items():
+            self.assertIsNotNone(value, 'Key {0} has value None'.format(key))
diff --git a/web/pgadmin/tools/search_objects/tests/test_search_objects_helper.py b/web/pgadmin/tools/search_objects/tests/test_search_objects_helper.py
new file mode 100644
index 000000000..ec9c369b9
--- /dev/null
+++ b/web/pgadmin/tools/search_objects/tests/test_search_objects_helper.py
@@ -0,0 +1,117 @@
+import sys
+
+from pgadmin.tools.search_objects.utils import SearchObjectsHelper, current_app
+from pgadmin.utils.route import BaseTestGenerator
+
+if sys.version_info < (3, 3):
+    from mock import patch, MagicMock
+else:
+    from unittest.mock import patch, MagicMock
+
+
+class SearchObjectsHelperTest(BaseTestGenerator):
+    scenarios = [
+        ('scenario', dict(
+            node_blueprints=[
+                dict(node_type='table', coll_label='Tables',
+                     backend_supported=True),
+                dict(node_type='view', coll_label='Views',
+                     backend_supported=False),
+                dict(node_type='index', coll_label='Indexes',
+                     backend_supported=True),
+                dict(node_type='role', coll_label='Roles',
+                     backend_supported=True)
+            ],
+            all_node_types=['table', 'view', 'index'],
+            expected_show_node_prefs=dict(table=True, view=False, index=True),
+            expected_supported_types=dict(table='Tables', index='Indexes'),
+            expected_supported_types_skip=dict(table='Tables', view='Views',
+                                               index='Indexes'),
+            execute_dict_return_value=(
+                True, dict(rows=[
+                    dict(obj_name='name1', obj_type='table',
+                         obj_path='some/path', show_node=True,
+                         other_info=None, catalog_level='N'),
+                    dict(obj_name='name2', obj_type='view',
+                         obj_path='some1/path', show_node=True,
+                         other_info=None, catalog_level='D'),
+                    dict(obj_name='name3', obj_type='index',
+                         obj_path='some2/path1', show_node=True,
+                         other_info='oid', catalog_level='O'),
+                ])),
+            expected_search_op=(
+                True, [
+                    dict(name='name1', type='table', type_label='Tables',
+                         path='some/path',
+                         show_node=True, other_info=None, catalog_level='N'),
+                    dict(name='name2', type='view', type_label='Views',
+                         path='some1/path',
+                         show_node=True, other_info=None, catalog_level='D'),
+                    dict(name='name3', type='index', type_label='Indexes',
+                         path='some2/path1',
+                         show_node=True, other_info='oid', catalog_level='O'),
+                ]
+            )
+        ))
+    ]
+
+    def __create_manager(self):
+        connection = MagicMock(
+            execute_dict=MagicMock(),
+            db='somedb'
+        )
+        connection.execute_dict.return_value = self.execute_dict_return_value
+
+        def connection_function(did):
+            return connection
+
+        return MagicMock(
+            connection=connection_function
+        )
+
+    @patch('pgadmin.tools.search_objects.utils.get_node_blueprint')
+    @patch('pgadmin.tools.search_objects.utils.get_driver')
+    def runTest(self, get_driver_mock, get_node_blueprint_mock):
+        manager = self.__create_manager()
+
+        get_driver_mock.return_value = MagicMock(
+            connection_manager=lambda session_id: manager)
+
+        def __get_node_blueprint_mock(node_type):
+            blueprints = self.node_blueprints
+            blueprint = None
+            for data in blueprints:
+                if node_type == data['node_type']:
+                    blueprint = MagicMock(
+                        BackendSupported=MagicMock(
+                            return_value=data['backend_supported']),
+                        collection_label=data['coll_label'],
+                        show_node=data['backend_supported'],
+                    )
+            return blueprint
+
+        get_node_blueprint_mock.side_effect = __get_node_blueprint_mock
+
+        with self.app.app_context():
+
+            so_obj = SearchObjectsHelper(2, 18456,
+                                         node_types=self.all_node_types)
+            so_obj.get_sql = MagicMock(return_value='dummy query')
+
+            # test template path
+            manager.server_type = 'pg'
+            manager.version = 906000
+            self.assertEquals(so_obj.get_template_path(),
+                              'search_objects/sql/pg/#906000#')
+
+            self.assertEquals(so_obj.get_show_node_prefs(),
+                              self.expected_show_node_prefs)
+
+            self.assertEquals(so_obj.get_supported_types(),
+                              self.expected_supported_types)
+
+            self.assertEquals(so_obj.get_supported_types(skip_check=True),
+                              self.expected_supported_types_skip)
+
+            self.assertEquals(so_obj.search('searchtext', 'all'),
+                              self.expected_search_op)
